- README

- Top Level Namespace
- Adler32
- ArgumentError
- Array
- Atomic
- Base64
  - Error
- Benchmark
  - BM
    - Job
    - Tms
  - IPS
    - Entry
    - Job
- BigFloat
- BigInt
- BigRational
- BitArray
- Bool
- Box
- Bytes
- Channel
  - Buffered
  - ClosedError
  - ReceiveAction
  - SelectAction
  - SendAction
  - Unbuffered
- Char
  - Reader
- Class
- Colorize
  - Object
  - ObjectExtensions
- Comparable
- Complex
- Concurrent
  - CanceledError
- CRC32
- Crypto
  - Bcrypt
    - Error
    - Password
  - Blowfish
  - Subtle
- Crystal
  - Macros
    - And
    - Arg
    - ArrayLiteral
    - Assign
    - ASTNode
    - BinaryOp
    - Block
    - BoolLiteral
    - Call
    - Case
    - Cast
    - CharLiteral
    - ClassDef
    - ClassVar
    - Def
    - Expressions
    - Generic
    - Global
    - HashLiteral
    - If
    - ImplicitObj
    - InstanceSizeOf
    - InstanceVar
    - IsA
    - Macro
    - MacroId
    - MetaVar
    - MultiAssign
    - NamedArgument
    - NamedTupleLiteral
    - NilableCast
    - NilLiteral
    - Nop
    - Not
    - NumberLiteral
    - Or
    - Out
    - Path
    - PointerOf
    - RangeLiteral
    - ReadInstanceVar
    - RegexLiteral
    - Require
    - RespondsTo
    - SizeOf
    - Splat
    - StringInterpolation
    - StringLiteral
    - SymbolLiteral
    - TupleLiteral
    - TypeDeclaration
    - TypeNode
    - UnaryExpression
    - UninitializedVar
    - Union
    - Var
    - VisibilityModifier
    - When
    - While
  - System
- CSV
  - Builder
    - Row
  - Error
  - Lexer
  - MalformedCSVError
  - Parser
  - Row
  - Token
    - Kind
- Debug
  - DWARF
    - Abbrev
      - Attribute
    - AT
    - FORM
    - Info
      - Value
    - LineNumbers
      - Register
      - Row
      - Sequence
    - LNE
    - LNS
    - Strings
    - TAG
  - ELF
    - Endianness
    - Error
    - Ident
    - Klass
    - Machine
    - OSABI
    - SectionHeader
      - Flags
      - Type
    - Type
- Deque
- Digest
  - Base
  - MD5
  - SHA1
- Dir
- DivisionByZero
- DL
- ECR
- Enum
- Enumerable
  - EmptyError
- ENV
- Errno
- Exception
- Fiber
- File
  - Stat
- FileUtils
- Flate
  - Error
  - Reader
  - Strategy
  - Writer
- Float
  - Primitive
  - Printer
    - CachedPowers
      - Power
    - DiyFP
    - Grisu3
    - IEEE
- Float32
- Float64
- GC
  - Stats
- Gzip
  - Error
  - Header
  - Reader
  - Writer
- Hash
- HTML
- HTTP
  - Client
    - BodyType
    - Response
  - CompressHandler
  - ComputedContentTypeHeader
  - Cookie
  - Cookies
  - ErrorHandler
  - FormData
    - Builder
    - Error
    - FileMetadata
    - Parser
    - Part
  - Handler
    - Proc
  - Headers
  - LogHandler
  - Multipart
    - Builder
    - Error
    - Parser
  - Params
    - Builder
  - Request
  - Server
    - Context
    - RequestProcessor
    - Response
  - StaticFileHandler
    - DirectoryListing
  - WebSocket
  - WebSocketHandler
- Indexable
- IndexError
- INI
- Int
  - Primitive
  - Signed
  - Unsigned
- Int16
- Int32
- Int64
- Int8
- InvalidByteSequenceError
- IO
  - Buffered
  - ByteFormat
    - BigEndian
    - LittleEndian
    - NetworkEndian
    - SystemEndian
  - Delimited
  - EncodingOptions
  - EOFError
  - Error
  - FileDescriptor
  - Hexdump
  - Memory
  - MultiWriter
  - Seek
  - Sized
  - Timeout
- IPSocket
- Iterable
- Iterator
  - IteratorWrapper
  - Stop
- JSON
  - Any
  - Builder
    - ArrayState
    - DocumentEndState
    - DocumentStartState
    - ObjectState
    - StartState
    - State
  - Error
  - Lexer
  - ParseException
  - Parser
  - PullParser
  - Token
  - Type
- KeyError
- Levenshtein
  - Finder
- LLVM
  - ABI
    - AArch64
    - ArgKind
    - ArgType
    - ARM
    - FunctionType
    - X86
    - X86_64
      - RegClass
  - AtomicOrdering
  - AtomicRMWBinOp
  - Attribute
  - AttributeIndex
  - BasicBlock
  - BasicBlockCollection
  - Builder
  - CallConvention
  - CodeGenFileType
  - CodeGenOptLevel
  - CodeModel
  - Context
  - DIBuilder
  - DIFlags
  - DwarfTag
  - DwarfTypeEncoding
  - Function
  - FunctionCollection
  - FunctionPassManager
    - Runner
  - GenericValue
  - GlobalCollection
  - InstructionCollection
  - IntPredicate
  - JITCompiler
  - Linkage
  - MemoryBuffer
  - Module
  - ModuleFlag
  - ModulePassManager
  - OperandBundleDef
  - ParameterCollection
  - PassManagerBuilder
  - PassRegistry
  - PhiTable
  - RealPredicate
  - RelocMode
  - Target
  - TargetData
  - TargetMachine
  - Type
    - Kind
  - Value
    - Kind
  - ValueMethods
  - VerifierFailureAction
- Logger
  - Formatter
  - Severity
- Markdown
  - HTMLRenderer
  - Parser
    - PrefixHeader
    - UnorderedList
  - Renderer
- Math
- Mutex
- NamedTuple
- Nil
- Number
  - Primitive
- OAuth
  - AccessToken
  - Consumer
  - Error
  - RequestToken
- OAuth2
  - AccessToken
    - Bearer
    - Mac
  - Client
  - Error
  - Session
- Object
- OpenSSL
  - Digest
    - Error
    - UnsupportedError
  - DigestBase
  - DigestIO
    - DigestMode
  - Error
  - HMAC
  - MD5
  - SHA1
  - SSL
    - Context
      - Client
      - Server
    - Error
    - ErrorType
    - Modes
    - Options
    - Socket
      - Client
      - Server
    - VerifyMode
    - X509VerifyFlags
- OptionParser
  - Exception
  - InvalidOption
  - MissingOption
- PartialComparable
- Pointer
  - Appender
- PrettyPrint
- Proc
- Process
  - Env
  - Status
  - Stdio
  - Tms
- Random
  - ISAAC
  - MT19937
  - PCG32
  - System
- Range
- Readline
  - CompletionProc
  - KeyBindingProc
- Reference
- Reflect
- Regex
  - MatchData
  - Options
- SecureRandom
- Set
- Signal
- Slice
- Socket
  - Address
  - Addrinfo
  - Error
  - Family
  - IPAddress
  - Protocol
  - Server
  - Type
  - UNIXAddress
- Spec
  - Expectations
  - Methods
  - ObjectExtensions
- StaticArray
- String
  - Builder
  - RawConverter
- StringPool
- StringScanner
- Struct
- Symbol
- System
- TCPServer
- TCPSocket
- Tempfile
- Termios
  - AttributeSelection
  - BaudRate
  - ControlMode
  - InputMode
  - LineControl
  - LocalMode
  - OutputMode
- Time
  - DayOfWeek
  - EpochConverter
  - EpochMillisConverter
  - Format
    - Error
  - Kind
  - MonthSpan
  - Span
- Tuple
- TypeCastError
- UDPSocket
- UInt16
- UInt32
- UInt64
- UInt8
- Unicode
  - CaseOptions
- Union
- UNIXServer
- UNIXSocket
- URI
  - Error
- Value
- WeakRef
- XML
  - Attributes
  - AttributeType
  - Builder
  - Error
  - HTMLParserOptions
  - Namespace
  - Node
  - NodeSet
  - ParserOptions
  - Reader
  - SaveOptions
  - Type
  - XPathContext
- YAML
  - Any
  - Builder
  - Error
  - EventKind
  - ParseException
  - Parser
  - PullParser
  - Type
- Zip
  - CompressionMethod
  - Error
  - File
    - Entry
  - FileInfo
  - Reader
    - Entry
  - Writer
    - Entry
- Zlib
  - Error
  - Reader
  - Writer

# module FileUtils

## Extended Modules

- FileUtils

## Defined in:

## Instance Method Summary

- #cd(path : String)

  Changes the current working directory of the process to the given string path.

- #cd(path : String, &block)

  Changes the current working directory of the process to the given string path and invoked the block, restoring the original working directory when the block exits.

- #cmp(filename1 : String, filename2 : String)

  Compares two files filename1 to filename2 to determine if they are identical.

- #cmp(stream1 : IO, stream2 : IO)

  Compares two streams stream1 to stream2 to determine if they are identical.

- #cp(src_path : String, dest : String)

  Copies the file src_path to the file or directory dest.

- #cp(srcs : Enumerable(String), dest : String)

  Copies a list of files src to dest.

- #cp_r(src_path : String, dest_path : String)

  Copies a file or directory src_path to dest_path.

- #mkdir(path : String, mode = 511) : Nil

  Creates a new directory at the given path.

- #mkdir(paths : Enumerable(String), mode = 511) : Nil

  Creates a new directory at the given paths.

- #mkdir_p(paths : Enumerable(String), mode = 511) : Nil

  Creates a new directory at the given paths, including any non-existing intermediate directories.

- #mkdir_p(path : String, mode = 511) : Nil

  Creates a new directory at the given path, including any non-existing intermediate directories.

- #mv(src_path : String, dest_path : String) : Nil

  Moves src_path to dest_path.

- #mv(srcs : Enumerable(String), dest : String) : Nil

  Moves every srcs to dest.

- #pwd : String

  Returns the current working directory.

- #rm(path : String) : Nil

  Deletes the path file given.

- #rm(paths : Enumerable(String)) : Nil

  Deletes all paths file given.

- #rm_r(path : String) : Nil

  Deletes a file or directory path.

- #rm_r(paths : Enumerable(String)) : Nil

  Deletes a list of files or directories paths.

- #rm_rf(path : String) : Nil

  Deletes a file or directory path.

- #rm_rf(paths : Enumerable(String)) : Nil

  Deletes a list of files or directories paths.

- #rmdir(path : String) : Nil

  Removes the directory at the given path.

- #rmdir(paths : Enumerable(String)) : Nil

  Removes all directories at the given paths.

- #touch(paths : Enumerable(String), time : Time = Time.now)

  Attempts to set the access and modification times of each file given in the paths parameter to the value given in time.

- #touch(path : String, time : Time = Time.now)

  Attempts to set the access and modification times of the file named in the path parameter to the value given in time.

## Instance Method Detail

def cd(path : String) #

Changes the current working directory of the process to the given string path.

    require "file_utils"

    FileUtils.cd("/tmp")

NOTE Alias of `Dir.cd`

def cd(path : String, &block) #

Changes the current working directory of the process to the given string path and invoked the block, restoring the original working directory when the block exits.

    FileUtils.cd("/tmp") { Dir.current } # => "/tmp"

NOTE Alias of `Dir.cd` with block

def cmp(filename1 : String, filename2 : String) #

Compares two files filename1 to filename2 to determine if they are identical. Returns `true` if content are the same, `false` otherwise.

    File.write("file.cr", "1")
    File.write("bar.cr", "1")
    FileUtils.cmp("file.cr", "bar.cr") # => true

def cmp(stream1 : IO, stream2 : IO) #

Compares two streams stream1 to stream2 to determine if they are identical. Returns `true` if content are the same, `false` otherwise.

    File.write("afile", "123")
    stream1 = File.open("afile")
    stream2 = IO::Memory.new("123")
    FileUtils.cmp(stream1, stream2) # => true

def cp(src_path : String, dest : String) #

Copies the file src_path to the file or directory dest. If dest is a directory, a file with the same basename as src_path is created in dest Permission bits are copied too.

    File.chmod("afile", 0o600)
    FileUtils.cp("afile", "afile_copy")
    File.stat("afile_copy").perm # => 0o600

def cp(srcs : Enumerable(String), dest : String) #

Copies a list of files src to dest. dest must be an existing directory.

    Dir.mkdir("files")
    FileUtils.cp({"bar.cr", "afile"}, "files")

def cp_r(src_path : String, dest_path : String) #

Copies a file or directory src_path to dest_path. If src_path is a directory, this method copies all its contents recursively.

    FileUtils.cp_r("files", "dir")

def mkdir(path : String, mode = 511) : Nil #

Creates a new directory at the given path. The linux-style permission mode can be specified, with a default of 777 (0o777).

    FileUtils.mkdir("src")

NOTE Alias of `Dir.mkdir`

def mkdir(paths : Enumerable(String), mode = 511) : Nil #

Creates a new directory at the given paths. The linux-style permission mode can be specified, with a default of 777 (0o777).

    FileUtils.mkdir(["foo", "bar"])

def mkdir_p(paths : Enumerable(String), mode = 511) : Nil #

Creates a new directory at the given paths, including any non-existing intermediate directories. The linux-style permission mode can be specified, with a default of 777 (0o777).

    FileUtils.mkdir_p(["foo", "bar", "baz", "dir1", "dir2", "dir3"])

def mkdir_p(path : String, mode = 511) : Nil #

Creates a new directory at the given path, including any non-existing intermediate directories. The linux-style permission mode can be specified, with a default of 777 (0o777).

    FileUtils.mkdir_p("foo")

NOTE Alias of `Dir.mkdir_p`

def mv(src_path : String, dest_path : String) : Nil #

Moves src_path to dest_path.

    FileUtils.mv("afile", "afile.cr")

NOTE Alias of `File.rename`

def mv(srcs : Enumerable(String), dest : String) : Nil #

Moves every srcs to dest.

    FileUtils.mv(["foo", "bar"], "src")

def pwd : String #

Returns the current working directory.

    FileUtils.pwd

NOTE Alias of `Dir.current`

def rm(path : String) : Nil #

Deletes the path file given.

    FileUtils.rm("afile.cr")

NOTE Alias of `File.delete`

def rm(paths : Enumerable(String)) : Nil #

Deletes all paths file given.

    FileUtils.rm(["dir/afile", "afile_copy"])

def rm_r(path : String) : Nil #

Deletes a file or directory path. If path is a directory, this method removes all its contents recursively.

    FileUtils.rm_r("dir")
    FileUtils.rm_r("file.cr")

def rm_r(paths : Enumerable(String)) : Nil #

Deletes a list of files or directories paths. If one path is a directory, this method removes all its contents recursively.

    FileUtils.rm_r(["files", "bar.cr"])

def rm_rf(path : String) : Nil #

Deletes a file or directory path. If path is a directory, this method removes all its contents recursively. Ignore all errors.

    FileUtils.rm_rf("dir")
    FileUtils.rm_rf("file.cr")
    FileUtils.rm_rf("non_existent_file")

def rm_rf(paths : Enumerable(String)) : Nil #

Deletes a list of files or directories paths. If one path is a directory, this method removes all its contents recursively. Ignore all errors.

    FileUtils.rm_rf(["dir", "file.cr", "non_existent_file"])

def rmdir(path : String) : Nil #

Removes the directory at the given path.

    FileUtils.rmdir("baz")

NOTE Alias of `Dir.rmdir`

def rmdir(paths : Enumerable(String)) : Nil #

Removes all directories at the given paths.

    FileUtils.rmdir(["dir1", "dir2", "dir3"])

def touch(paths : Enumerable(String), time : Time = Time.now) #

Attempts to set the access and modification times of each file given in the paths parameter to the value given in time.

If the file does not exist, it will be created.

    FileUtils.touch(["foo", "bar"])

def touch(path : String, time : Time = Time.now) #

Attempts to set the access and modification times of the file named in the path parameter to the value given in time.

If the file does not exist, it will be created.

    FileUtils.touch("afile.cr")

NOTE Alias of `File.touch`